## persalys 13.1.1+ds

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.8)

option ( BUILD_PYTHON                 "Build the python module for the library"                               ON )
option ( BUILD_GUI                    "Build the GUI"                                                         ON )
option ( BUILD_SHARED_LIBS            "Build shared libraries"                                                ON )
option (USE_SALOME "use salome" ON)
option (USE_OTFMI "use otfmi" ON)
option (USE_OTMORRIS "use otmorris" ON)
option (USE_SPHINX "use sphinx" ON)
option (USE_COTIRE "Use cotire for unity builds" OFF)
option (USE_PARAVIEW "use ParaView" ON)
set (PERSALYS_QT_VERSION 5 CACHE STRING "Qt version")

# By default, build in Release mode. Must appear before project() command
if ( NOT DEFINED CMAKE_BUILD_TYPE )
   set( CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project (Persalys)

if (POLICY CMP0020)
  cmake_policy (SET CMP0020 NEW)
endif ()

string ( TOLOWER ${CMAKE_PROJECT_NAME} PACKAGE_NAME )

# set module dir to find custom scripts
list ( APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake )


if (USE_COTIRE)
  if (POLICY CMP0058)
    # Ninja requires custom command byproducts to be explicit
    cmake_policy (SET CMP0058 NEW)
  endif()
  include (cotire)
endif ()

include (GNUInstallDirs)

# add library with unity build support, inspired by https://github.com/onqtam/ucm
macro (persalys_add_library name)
  if (USE_COTIRE)
    set (orig_target ${name}_orig)
    # add regular target with another name
    add_library (${orig_target} ${ARGN})
    set_target_properties (${orig_target} PROPERTIES EXCLUDE_FROM_ALL 1 EXCLUDE_FROM_DEFAULT_BUILD 1)
    # set unity target name with the original name
    set_target_properties (${orig_target} PROPERTIES COTIRE_UNITY_TARGET_NAME ${name})
    # add unity build target
    cotire (${orig_target})
    set_target_properties (${name} PROPERTIES EXCLUDE_FROM_ALL 0 EXCLUDE_FROM_DEFAULT_BUILD 0)
    set_target_properties (${name} PROPERTIES OUTPUT_NAME ${name})
  else ()
    add_library (${name} ${ARGN})
  endif ()
endmacro ()

find_package (OpenTURNS 1.20 CONFIG REQUIRED)
message (STATUS "Found OpenTURNS: ${OPENTURNS_ROOT_DIR} (found version \"${OPENTURNS_VERSION_STRING}\")")
list (APPEND PERSALYS_PUBLIC_LIBRARIES ${OPENTURNS_LIBRARIES})

if (NOT BUILD_SHARED_LIBS)
  list (APPEND PERSALYS_DEFINITIONS "-DPERSALYS_STATIC -DPYINTERP_STATIC -DPYCONSOLE_STATIC")
endif ()

find_package (Boost COMPONENTS filesystem locale REQUIRED)
list (APPEND PERSALYS_PRIVATE_LIBRARIES ${Boost_LIBRARIES})
include_directories (${Boost_INCLUDE_DIRS})

find_package (PythonInterp 3.5)
find_package (PythonLibs ${PYTHON_VERSION_STRING} EXACT REQUIRED)
list (APPEND PERSALYS_PUBLIC_LIBRARIES ${PYTHON_LIBRARIES})

if (BUILD_GUI)

  find_package (Qt${PERSALYS_QT_VERSION} COMPONENTS Widgets Test OpenGL CONFIG)
  set (QT_LIBRARIES ${Qt${PERSALYS_QT_VERSION}Widgets_LIBRARIES} ${Qt${PERSALYS_QT_VERSION}OpenGL_LIBRARIES} ${Qt${PERSALYS_QT_VERSION}Test_LIBRARIES})

  if (Qt${PERSALYS_QT_VERSION}Widgets_VERSION VERSION_LESS 5.15)
    macro (qt_wrap_cpp)
      qt5_wrap_cpp (${ARGN})
    endmacro ()

    macro (qt_add_resources)
      qt5_add_resources (${ARGN})
    endmacro ()

    macro (qt_generate_moc)
      qt5_generate_moc (${ARGN})
    endmacro ()
  endif ()

  find_package (Qwt 6 REQUIRED)

  if (USE_PARAVIEW)
    find_package (ParaView 5.8 CONFIG)
    if (ParaView_FOUND)
      message(STATUS "Found ParaView: ${ParaView_DIR} (found version \"${ParaView_VERSION}\")")
      list (APPEND PERSALYS_DEFINITIONS -DPERSALYS_HAVE_PARAVIEW)
    endif ()
  endif ()

endif ()

if (USE_SALOME)
  find_package (SalomeKERNEL CONFIG)
  find_package (Qt5WebEngine CONFIG)
  find_package (Qt5WebEngineWidgets CONFIG)
  find_package (SalomeGUI CONFIG)
  find_package (SalomeYACS CONFIG)
  find_package (Py2cpp CONFIG)
  find_package (ydefx CONFIG)
  if (SalomeYACS_FOUND AND ydefx_FOUND)
    list (APPEND PERSALYS_DEFINITIONS ${YACS_DEFINITIONS})
    list (APPEND PERSALYS_DEFINITIONS -DPERSALYS_HAVE_YACS)
    include_directories (${YACS_INCLUDE_DIRS})
    list (APPEND PERSALYS_PUBLIC_LIBRARIES ydefx)
  endif ()

  find_package (AdaoCppLayer)
  if (AdaoCppLayer_FOUND)
    list (APPEND PERSALYS_DEFINITIONS -DPERSALYS_HAVE_ADAO_CPP_LAYER)
    include_directories (${AdaoCppLayer_INCLUDE_DIRS})
    list (APPEND PERSALYS_PRIVATE_LIBRARIES ${AdaoCppLayer_LIBRARIES})
  endif ()
endif ()

if (USE_OTFMI)
  include (FindPythonModule)
  find_python_module (otfmi)
  if (OTFMI_FOUND)
    list (APPEND PERSALYS_DEFINITIONS -DPERSALYS_HAVE_OTFMI)
    list (APPEND PERSALYS_DEFINITIONS -DOTFMI_VERSION_STRING="${OTFMI_VERSION_STRING}")
  endif ()
endif ()

if (USE_OTMORRIS)
  find_package (OTMORRIS 0.9 CONFIG)
  if (OTMORRIS_FOUND)
    message (STATUS "Found OTMORRIS: ${OTMORRIS_DIR} (found version \"${OTMORRIS_VERSION}\")")
    list (APPEND PERSALYS_DEFINITIONS -DPERSALYS_HAVE_OTMORRIS)
    list (APPEND PERSALYS_DEFINITIONS -DOTMORRIS_VERSION_STRING="${OTMORRIS_VERSION}")
    list (APPEND PERSALYS_PRIVATE_LIBRARIES ${OTMORRIS_LIBRARIES})
    include_directories (${OTMORRIS_INCLUDE_DIRS})
  endif ()
endif ()

set ( PERSALYS_LIBRARY_PATH ${CMAKE_INSTALL_LIBDIR} )
set ( PERSALYS_INCLUDE_PATH include )
set ( PERSALYS_SWIG_INCLUDE_PATH ${PERSALYS_INCLUDE_PATH}/${PACKAGE_NAME}/swig )
set ( PERSALYS_DATA_PATH share )
set ( PERSALYS_CONFIG_CMAKE_PATH ${CMAKE_INSTALL_LIBDIR}/cmake/persalys )
set ( DOC_INSTALL_PATH share/${PACKAGE_NAME}/doc )

# beware swig<3.0 does not like c++11: https://github.com/swig/swig/issues/73
set (CMAKE_CXX_STANDARD 11)

list (APPEND PERSALYS_DEFINITIONS -DDOCUMENTATION_INSTALL_PATH="${DOC_INSTALL_PATH}")

if (BUILD_PYTHON)
  find_package (SWIG)
  if (SWIG_FOUND)
    include (${SWIG_USE_FILE})
  endif ()

  include (FindPythonModule)

  if (USE_SPHINX)
    find_program (SPHINX_EXECUTABLE NAMES sphinx-build DOC "Sphinx Documentation Builder (sphinx-doc.org)")
    if (SPHINX_EXECUTABLE)
      find_python_module (sphinx 1.1)
      find_python_module (numpydoc)
    endif ()
    if (NOT SPHINX_EXECUTABLE OR NOT SPHINX_FOUND OR NOT NUMPYDOC_FOUND)
      set (SPHINX_FOUND FALSE)
      message (STATUS "Disabling documentation (requires sphinx/numpydoc)")
    endif ()
  endif ()

  if (NOT DEFINED PYTHON_SITE_PACKAGES AND NOT CMAKE_CROSSCOMPILING)
    execute_process (COMMAND ${PYTHON_EXECUTABLE} -c "import sysconfig, os; print(sysconfig.get_path('platlib').replace(sysconfig.get_path('data'), '').lstrip(os.path.sep))"
                    OUTPUT_VARIABLE PYTHON_SITE_PACKAGES OUTPUT_STRIP_TRAILING_WHITESPACE)
    file (TO_CMAKE_PATH "${PYTHON_SITE_PACKAGES}" PYTHON_SITE_PACKAGES)
  endif ()

  if (PYTHONINTERP_FOUND)
    if (DEFINED PYTHON_SITE_PACKAGES)
      set (PERSALYS_PYTHON_MODULE_PATH "${PYTHON_SITE_PACKAGES}")
    else ()
     if (WIN32)
       set (PERSALYS_PYTHON_MODULE_PATH Lib/site-packages)
     else ()
       set (PERSALYS_PYTHON_MODULE_PATH ${CMAKE_INSTALL_LIBDIR}/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages)
      endif ()
    endif ()

    set (PERSALYS_PYTHON${PYTHON_VERSION_MAJOR}_MODULE_PATH ${PERSALYS_PYTHON_MODULE_PATH})
  endif ( PYTHONINTERP_FOUND )
endif ()


# WARNING: This is where variables without OPENTURNS_ prefix are defined !
foreach ( _var PYTHON_MODULE_PATH LIBRARY_PATH INCLUDE_PATH CONFIG_CMAKE_PATH)
  if ( NOT IS_ABSOLUTE PERSALYS_${_var} )
    set ( PERSALYS_${_var} ${CMAKE_INSTALL_PREFIX}/${PERSALYS_${_var}} )
  endif ()
  set ( ${_var} ${PERSALYS_${_var}} )
endforeach ( _var )

# RPATH settings
set (CMAKE_INSTALL_RPATH ${LIBRARY_PATH} ${OTMORRIS_LIBRARY_DIRS})
set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
if (POLICY CMP0042)
  # MACOSX_RPATH is enabled by default
  cmake_policy(SET CMP0042 NEW)
endif()
if (POLICY CMP0078)
  # UseSWIG generates standard target names
  cmake_policy(SET CMP0078 NEW)
endif()
if (POLICY CMP0086)
  # UseSWIG honors SWIG_MODULE_NAME via -module flag
  cmake_policy(SET CMP0086 NEW)
endif()

# Some useful macros to ease CMakeLists.txt file writing
set ( SOURCEFILES "" CACHE INTERNAL "List of source files to compile" )
macro ( ot_add_source_file FILENAME )
  set ( sf ${SOURCEFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME} )
  set ( SOURCEFILES ${sf} CACHE INTERNAL "List of source files to compile" )
endmacro ( ot_add_source_file )

set ( HEADERFILES "" CACHE INTERNAL "List of header files to install" )
macro ( ot_install_header_file FILENAME )
  set ( hf ${HEADERFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${PACKAGE_NAME}/${FILENAME} )
  set ( HEADERFILES ${hf} CACHE INTERNAL "List of header files to install" )
endmacro ( ot_install_header_file )

set ( SWIGFILES "" CACHE INTERNAL "List of SWIG files to install" )
macro ( ot_install_swig_file FILENAME )
  set ( hf ${SWIGFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME} )
  set ( SWIGFILES ${hf} CACHE INTERNAL "List of SWIG files to install" )
endmacro ( ot_install_swig_file )

set ( INTERNAL_INCLUDE_DIRS "" CACHE INTERNAL "List of directories with header files needed for build" )
macro ( ot_add_current_dir_to_include_dirs )
  set ( inc_dirs ${INTERNAL_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR} )
  set ( INTERNAL_INCLUDE_DIRS ${inc_dirs} CACHE INTERNAL "List of directories with header files needed for build" )
endmacro ( ot_add_current_dir_to_include_dirs )


set ( CPACK_PACKAGE_NAME          ${PACKAGE_NAME} )
set ( CPACK_PACKAGE_VERSION_MAJOR 13              )
set ( CPACK_PACKAGE_VERSION_MINOR 1              )
set ( CPACK_PACKAGE_VERSION_PATCH 1               )
set ( CPACK_SOURCE_GENERATOR      "TGZ;TBZ2"     )
set ( CPACK_BINARY_STGZ           OFF CACHE BOOL "STGZ")
set ( CPACK_BINARY_TBZ2           ON  CACHE BOOL "TBZ2")
set ( CPACK_BINARY_TGZ            ON  CACHE BOOL "TGZ")
set ( CPACK_BINARY_TZ             OFF CACHE BOOL "TZ")
set ( CPACK_SOURCE_IGNORE_FILES "/.git;/build;.*~;.*exe;.*AppImage;.*doc.zip;${CPACK_SOURCE_IGNORE_FILES}" )
set ( PACKAGE_NAME           ${CPACK_PACKAGE_NAME} )
set ( PACKAGE_VERSION        ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR} )
if ( CPACK_PACKAGE_VERSION_PATCH )
  set ( PACKAGE_VERSION       ${PACKAGE_VERSION}.${CPACK_PACKAGE_VERSION_PATCH} )
endif ()
set ( CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION} )

# uninstall target
configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
  IMMEDIATE @ONLY
)

add_custom_target ( uninstall
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

set ( PERSALYS_LIBRARY                 persalys )
set ( PERSALYS_LIBRARIES ${OPENTURNS_LIBRARIES} )
list ( APPEND PERSALYS_LIBRARIES ${PERSALYS_LIBRARY} )
set ( PERSALYS_LIBRARY_DIRS ${OPENTURNS_LIBRARY_DIRS})
if (OTMORRIS_FOUND)
  list ( APPEND PERSALYS_LIBRARY_DIRS ${OTMORRIS_LIBRARY_DIRS} )
endif ()
list ( APPEND PERSALYS_LIBRARY_DIRS ${LIBRARY_PATH} )
set ( PERSALYS_INCLUDE_DIR ${PERSALYS_INCLUDE_PATH} )
set ( PERSALYS_INCLUDE_DIRS ${PERSALYS_INCLUDE_DIR} )
set ( PERSALYS_ROOT_DIR       ${CMAKE_INSTALL_PREFIX} )
list ( APPEND PERSALYS_INCLUDE_DIRS ${OPENTURNS_INCLUDE_DIRS} )
set ( PERSALYS_VERSION_STRING ${PACKAGE_VERSION} )
set ( PERSALYS_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR} )
set ( PERSALYS_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR} )
set ( PERSALYS_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH} )
set ( PERSALYS_USE_FILE      ${PERSALYS_CONFIG_CMAKE_PATH}/UsePersalys.cmake )

list (APPEND PERSALYS_DEFINITIONS -DPERSALYS_VERSION="${PERSALYS_VERSION_STRING}")
list (APPEND PERSALYS_DEFINITIONS -DINSTALL_PATH="${CMAKE_INSTALL_PREFIX}")

add_definitions (${PERSALYS_DEFINITIONS})

# The tests can't be run if this function is absent
enable_testing ()
add_custom_target ( tests COMMENT "Build tests" )
add_custom_target ( check COMMENT "Run pre-installation tests" )
add_custom_target ( installcheck COMMENT "Run post-installation tests" )

add_subdirectory ( lib )

add_subdirectory ( translations )

add_dependencies ( check cppcheck )

=== lib/CMakeLists.txt ===

add_subdirectory ( include )
add_subdirectory ( src )
add_subdirectory ( test )

install ( FILES ${HEADERFILES}
          DESTINATION ${PERSALYS_INCLUDE_PATH}/${PACKAGE_NAME}
        )

=== main/CMakeLists.txt ===

include_directories (${CMAKE_SOURCE_DIR}/lib/include)

include_directories (${CMAKE_SOURCE_DIR}/lib/src/base)
include_directories (${CMAKE_SOURCE_DIR}/lib/src/model)

include_directories (${CMAKE_SOURCE_DIR}/lib/src/view)
include_directories (${CMAKE_SOURCE_DIR}/lib/src/view/PyConsole)

add_executable (persalys WIN32 main.cxx gui.rc)

target_link_libraries (persalys persalysview)
set_target_properties (persalys PROPERTIES UNITY_BUILD OFF)

if (UNIX)
  set (launch_file ${CMAKE_BINARY_DIR}/persalys.sh)
  file (WRITE ${launch_file} "#!/bin/sh\n")
  file (APPEND ${launch_file} "export PERSALYS_HTML_DOCUMENTATION_PATH=${CMAKE_INSTALL_PREFIX}/share/persalys/doc/html/\n")
  if (OPENTURNS_PYTHON${PYTHON_VERSION_MAJOR}_MODULE_PATH)
    file (APPEND ${launch_file} "PYTHONPATH=$PYTHONPATH:${OPENTURNS_PYTHON${PYTHON_VERSION_MAJOR}_MODULE_PATH}\n")
  endif ()
  foreach (PYTHON_MODULE_PATH ${PERSALYS_PYTHON_MODULE_PATH})
    file (APPEND ${launch_file} "PYTHONPATH=$PYTHONPATH:${PYTHON_MODULE_PATH}\n")
  endforeach ()
  file (APPEND ${launch_file} "export PYTHONPATH\n")
  if (ParaView_FOUND)
    file (APPEND ${launch_file} "PV_PLUGIN_PATH=$PV_PLUGIN_PATH:${ParaView_PREFIX_PATH}/lib/${PARAVIEW_PLUGIN_SUBDIR}/BagPlotViewsAndFilters\n")
    file (APPEND ${launch_file} "export PV_PLUGIN_PATH\n")
  endif ()
  file (APPEND ${launch_file} "${CMAKE_CURRENT_BINARY_DIR}/persalys &\n")
  execute_process (COMMAND chmod a+rx ${launch_file})
endif ()

install (TARGETS persalys DESTINATION bin)

=== lib/src/CMakeLists.txt ===

add_subdirectory (base)

if (BUILD_GUI)
  add_subdirectory (model)
  add_subdirectory (view)
endif ()

=== lib/test/CMakeLists.txt ===

set ( PATH_SEP ":" )
if (WIN32)
  # replace dos eols
  set (REPLACE_EOL " | tr -d '\\\\015' ")
  set ( PATH_SEP "\\;" )

  if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    add_library (CRT_fp8 STATIC CRT_fp8.c)
  endif ()
endif ()

set (CHECK_ENVIRONMENT
     "PYTHONPATH=${OPENTURNS_PYTHON${PYTHON_VERSION_MAJOR}_MODULE_PATH}${PATH_SEP}${OTMORRIS_PYTHON${PYTHON_VERSION_MAJOR}_MODULE_PATH}${PATH_SEP}${INSTALL_DESTDIR}${PERSALYS_PYTHON_MODULE_PATH}${PATH_SEP}$ENV{PYTHONPATH}"
    )

set ( CHECK_TO_BE_RUN )
macro ( ot_check_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.cxx )
  set ( TESTNAME_SRCS ${TESTNAME_SRC} )
  add_executable ( ${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRCS} )
  add_dependencies ( tests ${TESTNAME_TGT} )
  target_link_libraries ( ${TESTNAME_TGT} persalysbase )
  if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_link_libraries (${TESTNAME_TGT} CRT_fp8)
  endif ()
  set_target_properties ( ${TESTNAME_TGT} PROPERTIES
                                          UNITY_BUILD OFF
                                          INSTALL_RPATH "${CMAKE_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}" )
  set ( TESTNAME_LOC ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}${CMAKE_EXECUTABLE_SUFFIX} )
  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${CMAKE_CROSSCOMPILING_EMULATOR} ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
  else (_IGNOREOUT)
    set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
    set ( OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT} )
    set ( COMMAND "( ${CMAKE_CROSSCOMPILING_EMULATOR} ${TESTNAME_LOC} ${_PARAMS} ${REPLACE_EOL} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set ( COMMAND "${_PRE}${COMMAND}${_POST}" )
  endif (_PRE OR _POST)

  add_test ( cppcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )
  set_tests_properties ( cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}" )
  list ( APPEND CHECK_TO_BE_RUN ${TESTNAME_TGT} )
endmacro ()


macro (ot_qt_check_test TESTNAME)
  set (TESTNAME_TGT t_${TESTNAME})
  set (TESTNAME_MOC ${TESTNAME_TGT}.moc)
  set (TESTNAME_SRC ${TESTNAME_TGT}.cxx)
  set (TESTNAME_SRCS ${TESTNAME_SRC} ${TESTNAME_MOC})
  qt_generate_moc (${TESTNAME_SRC} ${TESTNAME_MOC})
  add_executable (${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRCS})
  add_dependencies (tests ${TESTNAME_TGT} )
  target_link_libraries (${TESTNAME_TGT} persalysview)
  set_target_properties (${TESTNAME_TGT} PROPERTIES UNITY_BUILD OFF)
  set (TEST_ARGUMENTS "${ARGV}")
  list (REMOVE_AT TEST_ARGUMENTS 0)

  # for MinGW from Linux QTest does not print anything when stdout is redirected, see QPlainTestLogger::outputMessage
  if (MINGW AND CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux")
    list (APPEND TEST_ARGUMENTS "-o;/dev/stderr,txt")
  endif ()

  add_test (NAME cppcheck_${TESTNAME} COMMAND ${TESTNAME_TGT} ${TEST_ARGUMENTS})
  set_tests_properties (cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}")
endmacro ()


include_directories (${QWT_INCLUDE_DIRS})
include_directories ( ${INTERNAL_INCLUDE_DIRS} )


# because of PhysicalModel_std where we need Python.h
include_directories (${PYTHON_INCLUDE_DIRS})

ot_check_test ( PhysicalModel_std )
ot_check_test ( Cogeneration_std )

if (BUILD_GUI)
  include_directories (${CMAKE_CURRENT_BINARY_DIR}) # for mocs
  execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/test_deterministic_analyses.xml ${CMAKE_CURRENT_BINARY_DIR})
  execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/test_probabilistic_analyses.xml ${CMAKE_CURRENT_BINARY_DIR})
  execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/test_field_analyses.xml ${CMAKE_CURRENT_BINARY_DIR})
  ot_qt_check_test (WelcomeWindow_std)
  ot_qt_check_test (MainWindow_std -platform minimal)
  ot_qt_check_test (OptimizationWizard_std)
  ot_qt_check_test (CentralTendencyWizard_std)
  ot_qt_check_test (SensitivityAnalysisWizard_std)
  if (OTMORRIS_FOUND)
    ot_qt_check_test (ScreeningAnalysisWizard_std)
  endif ()
  ot_qt_check_test (ModelEvaluationWizard_std)
  ot_qt_check_test (DesignOfExperimentEvaluationWizard_std)
  ot_qt_check_test (ReliabilityAnalysisWizard_std)
  ot_qt_check_test (MetaModelAnalysisWizard_std)
  ot_qt_check_test (DesignOfExperimentWizard_std)
  ot_qt_check_test (FieldMonteCarloWizard_std)
  ot_qt_check_test (MeshDefinitionWizard_std)
  ot_qt_check_test (CalibrationAnalysisWizard_std -platform minimal)
  ot_qt_check_test (ObservationsWizard_std)
  ot_qt_check_test (SymbolicPhysicalModelWindow_std)
  ot_qt_check_test (ProbabilisticModelWindow_std -platform minimal)
  ot_qt_check_test (DataModelWindow_std)
  ot_qt_check_test (QtTools_std)
  if (UNIX)
    set (PLATFORM_OFFSCREEN -platform offscreen)
  endif ()
  ot_qt_check_test (MonteCarloResultWindow_std ${PLATFORM_OFFSCREEN})
endif ()

add_custom_target ( cppcheck COMMAND ${CMAKE_CTEST_COMMAND} -R "^cppcheck_"
                    DEPENDS ${CHECK_TO_BE_RUN}
                    COMMENT "Run C++ pre-installation tests" )

if (SalomeYACS_FOUND)
  ot_check_test (YACSPhysicalModel_std IGNOREOUT)
  set_tests_properties (cppcheck_YACSPhysicalModel_std PROPERTIES RUN_SERIAL ON)
endif ()

=== python/test/CMakeLists.txt ===


set (PATH_SEP ":")
if (WIN32)
  # replace dos eols
  set (REPLACE_EOL " | tr -d '\\\\015' ")

  set (PATH_SEP "\\;")
endif ()

set ( PYINSTALLCHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${INSTALL_DESTDIR}${SYSCONFIG_PATH}/openturns"
	                         "PYTHONPATH=${OPENTURNS_PYTHON${PYTHON_VERSION_MAJOR}_MODULE_PATH}${PATH_SEP}${OTMORRIS_PYTHON${PYTHON_VERSION_MAJOR}_MODULE_PATH}${PATH_SEP}${INSTALL_DESTDIR}${PERSALYS_PYTHON_MODULE_PATH}${PATH_SEP}$ENV{PYTHONPATH}"
    )

add_executable(dummyAnsys ansysConnector/dummyAnsys.cxx)

set ( PYINSTALLCHECK_TO_BE_RUN )
macro ( ot_pyinstallcheck_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.py )
  set ( TESTNAME_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_SRC})
  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
  else (_IGNOREOUT)
    set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
    set ( OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT} )
    set ( COMMAND "( ${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} ${REPLACE_EOL} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set ( COMMAND "${_PRE}${COMMAND}${_POST}" )
  endif (_PRE OR _POST)

  add_test ( pyinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )

  set_tests_properties ( pyinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}" )
  list ( APPEND PYINSTALLCHECK_TO_BE_RUN ${TESTNAME_SRC} )
endmacro ( ot_pyinstallcheck_test )

if (NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  execute_process (COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/Housing-prices-Boston.csv ${CMAKE_CURRENT_BINARY_DIR})
endif ()

ot_pyinstallcheck_test (SymbolicPhysicalModel_std)
ot_pyinstallcheck_test (PythonPhysicalModel_std)
if (OTFMI_FOUND AND NOT CMAKE_CROSSCOMPILING)
  ot_pyinstallcheck_test (FMIPhysicalModel_std IGNOREOUT)
endif ()
if (NOT CMAKE_CROSSCOMPILING)
  ot_pyinstallcheck_test (PythonPhysicalModel_mp)
  ot_pyinstallcheck_test (DesignOfExperiment_mp IGNOREOUT)
endif ()
ot_pyinstallcheck_test (CouplingPhysicalModel_std)
ot_pyinstallcheck_test (AnsysParser_std)
ot_pyinstallcheck_test (CouplingPhysicalModel_logistic)
ot_pyinstallcheck_test (features IGNOREOUT)
ot_pyinstallcheck_test (Cogeneration_std)
ot_pyinstallcheck_test (Crue_std)
ot_pyinstallcheck_test (DesignOfExperiment_std)
ot_pyinstallcheck_test (AxialStressedBeam_std)
ot_pyinstallcheck_test (CantileverBeam_std)
ot_pyinstallcheck_test (DataModel_std)
ot_pyinstallcheck_test (FunctionalChaosAnalysis_std)
ot_pyinstallcheck_test (KrigingAnalysis_std)
ot_pyinstallcheck_test (MetaModelAnalysis_std IGNOREOUT)
ot_pyinstallcheck_test (PolynomialRegressionAnalysis_std IGNOREOUT)
ot_pyinstallcheck_test (MonteCarloAnalysis_std)
ot_pyinstallcheck_test (MonteCarloReliabilityAnalysis_std)
ot_pyinstallcheck_test (ImportanceSamplingAnalysis_std)
ot_pyinstallcheck_test (FORMAnalysis_std)
ot_pyinstallcheck_test (SORMAnalysis_std)
ot_pyinstallcheck_test (FORMImportanceSamplingAnalysis_std)
ot_pyinstallcheck_test (TaylorExpansionMomentsAnalysis_std)
ot_pyinstallcheck_test (SobolAnalysis_std)
ot_pyinstallcheck_test (SRCAnalysis_std)
ot_pyinstallcheck_test (LimitState_std)
ot_pyinstallcheck_test (InferenceAnalysis_std)
ot_pyinstallcheck_test (CopulaInferenceAnalysis_std)
if (OTMORRIS_FOUND)
ot_pyinstallcheck_test (MorrisAnalysis_std)
endif ()
ot_pyinstallcheck_test (OptimizationAnalysis_std)
ot_pyinstallcheck_test (MultiObjectiveOptimizationAnalysis_std)
ot_pyinstallcheck_test (MeshModel_std)
ot_pyinstallcheck_test (PythonFieldModel_std)
ot_pyinstallcheck_test (SymbolicFieldModel_std)
ot_pyinstallcheck_test (FieldModelEvaluation_std)
ot_pyinstallcheck_test (FieldMonteCarloAnalysis_std)
ot_pyinstallcheck_test (Observations_std)
ot_pyinstallcheck_test (CalibrationAnalysis_std)
ot_pyinstallcheck_test (Study_refCount)
ot_pyinstallcheck_test (Encoding_std)
ot_pyinstallcheck_test (docstring)
ot_pyinstallcheck_test (FileMemoizeFunction_std)
ot_pyinstallcheck_test (DataCleaning_std)

ot_pyinstallcheck_test (probabilistic_analyses IGNOREOUT)
ot_pyinstallcheck_test (field_analyses IGNOREOUT)
ot_pyinstallcheck_test (deterministic_analyses IGNOREOUT)

if (SalomeYACS_FOUND)
  ot_pyinstallcheck_test (YACSPhysicalModel_std IGNOREOUT)
  ot_pyinstallcheck_test (YACSCouplingPhysicalModel_std IGNOREOUT)
  set_tests_properties (pyinstallcheck_YACSPhysicalModel_std pyinstallcheck_YACSCouplingPhysicalModel_std PROPERTIES RUN_SERIAL ON)
endif ()

add_custom_target ( pyinstallcheck COMMAND ${CMAKE_CTEST_COMMAND} -R "^pyinstallcheck_"
                    DEPENDS ${PYINSTALLCHECK_TO_BE_RUN}
                    COMMENT "Run Python post-installation tests" )

=== lib/src/base/CMakeLists.txt ===
include_directories (${PYTHON_INCLUDE_DIRS})

ot_add_current_dir_to_include_dirs ()
include_directories (${INTERNAL_INCLUDE_DIRS})

set(BASE_SOURCEFILES DistributionDictionary.cxx
                     BaseTools.cxx
                     AppliException.cxx
                     Observer.cxx Observable.cxx Study.cxx StudyImplementation.cxx
                     Variable.cxx Input.cxx Output.cxx
                     DataSample.cxx
                     DataImport.cxx
                     DataModel.cxx
                     MeshModel.cxx MeshModelImplementation.cxx
                     GridMeshModel.cxx
                     ImportedMeshModel.cxx
                     PhysicalModel.cxx PhysicalModelImplementation.cxx SymbolicPhysicalModel.cxx
                     PythonPhysicalModel.cxx
                     MetaModel.cxx
                     SymbolicFieldModel.cxx
                     PythonScriptEvaluation.cxx
                     PythonScriptFieldFunction.cxx
                     PythonFieldModel.cxx
                     DesignOfExperimentImplementation.cxx DesignOfExperiment.cxx
                     FixedDesignOfExperiment.cxx
                     GridDesignOfExperiment.cxx
                     ImportedDesignOfExperiment.cxx
                     ProbabilisticDesignOfExperiment.cxx
                     AnalysisResult.cxx
                     EvaluationResult.cxx
                     AnalysisImplementation.cxx Analysis.cxx SimulationAnalysis.cxx
                     PhysicalModelAnalysis.cxx DesignOfExperimentAnalysis.cxx
                     WithStopCriteriaAnalysis.cxx
                     DataAnalysisResult.cxx DataAnalysis.cxx
                     ModelEvaluation.cxx
                     FieldModelEvaluation.cxx
                     DesignOfExperimentEvaluation.cxx
                     MonteCarloAnalysis.cxx TaylorExpansionMomentsResult.cxx
                     FieldMonteCarloAnalysis.cxx FieldMonteCarloResult.cxx
                     TaylorExpansionMomentsAnalysis.cxx SobolResult.cxx SobolAnalysis.cxx
                     SRCResult.cxx SRCAnalysis.cxx
                     LimitStateImplementation.cxx LimitState.cxx
                     ReliabilityAnalysis.cxx
                     SimulationInterface.cxx
                     SimulationReliabilityAnalysis.cxx
                     SimulationReliabilityResult.cxx
                     MonteCarloReliabilityAnalysis.cxx
                     ImportanceSamplingAnalysis.cxx
                     ApproximationAnalysis.cxx
                     FORMAnalysisResult.cxx FORMAnalysis.cxx
                     SORMAnalysisResult.cxx SORMAnalysis.cxx
                     FORMImportanceSamplingAnalysis.cxx
                     MetaModelAnalysis.cxx
                     MetaModelValidationResult.cxx
                     MetaModelAnalysisResult.cxx
                     FunctionalChaosAnalysisResult.cxx
                     FunctionalChaosAnalysis.cxx
                     KrigingAnalysisResult.cxx
                     KrigingAnalysis.cxx
                     PolynomialRegressionAnalysisResult.cxx
                     PolynomialRegressionAnalysis.cxx
                     FittingTestResult.cxx
                     InferenceResult.cxx
                     InferenceAnalysis.cxx
                     CopulaInferenceSetResult.cxx
                     CopulaInferenceResult.cxx
                     CopulaInferenceAnalysis.cxx
                     OptimizationAnalysis.cxx
                     MultiObjectiveOptimizationAnalysis.cxx
                     PythonEnvironment.cxx
                     Observations.cxx
                     CalibrationAnalysis.cxx
                     CalibrationAnalysisResult.cxx
                     CouplingInputFile.cxx
                     CouplingResourceFile.cxx
                     CouplingOutputFile.cxx
                     CouplingStep.cxx
                     CouplingPhysicalModel.cxx
                     FileMemoizeEvaluation.cxx
                     FileMemoizeFunction.cxx
                     DataCleaning.cxx
                     MorrisAnalysis.cxx
                     MorrisResult.cxx
                     FMIPhysicalModel.cxx
                     FMUInfo.cxx
                     AnsysParser.cxx
                     )
if (SalomeYACS_FOUND)
  list (APPEND BASE_SOURCEFILES YACSPhysicalModel.cxx YACSEvaluation.cxx YACSCouplingPhysicalModel.cxx)
endif ()
if (AdaoCppLayer_FOUND)
  list (APPEND BASE_SOURCEFILES AdaoCalibration.cxx)
endif ()

ot_install_header_file ( DistributionDictionary.hxx )
ot_install_header_file ( BaseTools.hxx )
ot_install_header_file ( AppliException.hxx )
ot_install_header_file ( Variable.hxx )
ot_install_header_file ( Input.hxx )
ot_install_header_file ( Output.hxx )
ot_install_header_file ( DataSample.hxx )
ot_install_header_file ( DataImport.hxx )
ot_install_header_file ( MeshModel.hxx )
ot_install_header_file ( MeshModelImplementation.hxx )
ot_install_header_file ( GridMeshModel.hxx )
ot_install_header_file ( ImportedMeshModel.hxx )
ot_install_header_file ( PhysicalModel.hxx )
ot_install_header_file ( PhysicalModelImplementation.hxx )
ot_install_header_file ( SymbolicPhysicalModel.hxx )
ot_install_header_file ( PythonPhysicalModel.hxx )
ot_install_header_file ( SymbolicFieldModel.hxx )
ot_install_header_file ( PythonScriptEvaluation.hxx )
ot_install_header_file ( PythonScriptFieldFunction.hxx )
ot_install_header_file ( PythonFieldModel.hxx )
ot_install_header_file ( MetaModel.hxx )
ot_install_header_file ( DesignOfExperimentImplementation.hxx )
ot_install_header_file ( DesignOfExperiment.hxx )
ot_install_header_file ( FixedDesignOfExperiment.hxx )
ot_install_header_file ( GridDesignOfExperiment.hxx )
ot_install_header_file ( ImportedDesignOfExperiment.hxx )
ot_install_header_file ( ProbabilisticDesignOfExperiment.hxx )
ot_install_header_file ( DataModel.hxx )
ot_install_header_file ( AnalysisResult.hxx )
ot_install_header_file ( EvaluationResult.hxx )
ot_install_header_file ( AnalysisImplementation.hxx )
ot_install_header_file ( PhysicalModelAnalysis.hxx )
ot_install_header_file ( DesignOfExperimentAnalysis.hxx )
ot_install_header_file ( Analysis.hxx )
ot_install_header_file ( SimulationAnalysis.hxx )
ot_install_header_file ( WithStopCriteriaAnalysis.hxx )
ot_install_header_file ( DataAnalysisResult.hxx )
ot_install_header_file ( DataAnalysis.hxx )
ot_install_header_file ( DesignOfExperimentEvaluation.hxx )
ot_install_header_file ( ModelEvaluation.hxx )
ot_install_header_file ( FieldModelEvaluation.hxx )
ot_install_header_file ( MonteCarloAnalysis.hxx )
ot_install_header_file ( FieldMonteCarloResult.hxx )
ot_install_header_file ( FieldMonteCarloAnalysis.hxx )
ot_install_header_file ( TaylorExpansionMomentsAnalysis.hxx )
ot_install_header_file ( TaylorExpansionMomentsResult.hxx )
ot_install_header_file ( SobolAnalysis.hxx )
ot_install_header_file ( SobolResult.hxx )
ot_install_header_file ( SRCAnalysis.hxx )
ot_install_header_file ( SRCResult.hxx )
ot_install_header_file ( Study.hxx )
ot_install_header_file ( StudyImplementation.hxx )
ot_install_header_file ( Observable.hxx )
ot_install_header_file ( Observer.hxx )
ot_install_header_file ( LimitStateImplementation.hxx )
ot_install_header_file ( LimitState.hxx )
ot_install_header_file ( ReliabilityAnalysis.hxx )
ot_install_header_file ( SimulationInterface.hxx )
ot_install_header_file ( SimulationReliabilityAnalysis.hxx )
ot_install_header_file ( SimulationReliabilityResult.hxx )
ot_install_header_file ( MonteCarloReliabilityAnalysis.hxx )
ot_install_header_file ( ImportanceSamplingAnalysis.hxx )
ot_install_header_file ( ApproximationAnalysis.hxx )
ot_install_header_file ( FORMAnalysis.hxx )
ot_install_header_file ( FORMAnalysisResult.hxx )
ot_install_header_file ( SORMAnalysis.hxx )
ot_install_header_file ( SORMAnalysisResult.hxx )
ot_install_header_file ( FORMImportanceSamplingAnalysis.hxx )
ot_install_header_file ( MetaModelValidationResult.hxx )
ot_install_header_file ( MetaModelAnalysisResult.hxx )
ot_install_header_file ( MetaModelAnalysis.hxx )
ot_install_header_file ( FunctionalChaosAnalysisResult.hxx )
ot_install_header_file ( FunctionalChaosAnalysis.hxx )
ot_install_header_file ( KrigingAnalysisResult.hxx )
ot_install_header_file ( KrigingAnalysis.hxx )
ot_install_header_file ( PolynomialRegressionAnalysisResult.hxx )
ot_install_header_file ( PolynomialRegressionAnalysis.hxx )
ot_install_header_file ( FittingTestResult.hxx )
ot_install_header_file ( InferenceResult.hxx )
ot_install_header_file ( InferenceAnalysis.hxx )
ot_install_header_file ( CopulaInferenceSetResult.hxx )
ot_install_header_file ( CopulaInferenceResult.hxx )
ot_install_header_file ( CopulaInferenceAnalysis.hxx )
ot_install_header_file ( OptimizationAnalysis.hxx )
ot_install_header_file ( MultiObjectiveOptimizationAnalysis.hxx )
ot_install_header_file ( PythonEnvironment.hxx )
ot_install_header_file ( LaunchParametersVisitor.hxx )
ot_install_header_file ( Observations.hxx )
ot_install_header_file ( CalibrationAnalysis.hxx )
ot_install_header_file ( CalibrationAnalysisResult.hxx )
ot_install_header_file ( CouplingInputFile.hxx )
ot_install_header_file ( CouplingResourceFile.hxx )
ot_install_header_file ( CouplingOutputFile.hxx )
ot_install_header_file ( CouplingStep.hxx )
ot_install_header_file ( DataCleaning.hxx )
ot_install_header_file (FMIPhysicalModel.hxx)
ot_install_header_file (FMUInfo.hxx)
ot_install_header_file (AnsysParser.hxx)
ot_install_header_file (MorrisAnalysis.hxx)
ot_install_header_file (MorrisResult.hxx)
ot_install_header_file (YACSPhysicalModel.hxx)
ot_install_header_file (YACSEvaluation.hxx)


persalys_add_library (persalysbase ${BASE_SOURCEFILES})
target_compile_features (persalysbase PRIVATE cxx_lambdas)

if (BUILD_SHARED_LIBS)
  target_compile_definitions (persalysbase PRIVATE PERSALYS_BASE_DLL_EXPORTS)
else ()
  target_compile_definitions (persalysbase PUBLIC PERSALYS_BASE_STATIC)
endif ()

if (NOT DEFINED LIB_VERSION)
  set (LIB_VERSION 0.0.0)
endif ()
if (NOT DEFINED LIB_SOVERSION)
  set (LIB_SOVERSION 0)
endif ()
set_target_properties (persalysbase PROPERTIES VERSION ${LIB_VERSION})
set_target_properties (persalysbase PROPERTIES SOVERSION ${LIB_SOVERSION})

target_link_libraries (persalysbase PUBLIC ${PERSALYS_PUBLIC_LIBRARIES})
target_link_libraries (persalysbase PRIVATE ${PERSALYS_PRIVATE_LIBRARIES})

install (TARGETS persalysbase
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${PERSALYS_LIBRARY_PATH}
  ARCHIVE DESTINATION ${PERSALYS_LIBRARY_PATH}
)

=== lib/src/model/CMakeLists.txt ===
set (SOURCEFILES "" CACHE STRING "" FORCE)

ot_add_current_dir_to_include_dirs ()

ot_add_source_file ( SampleTableModel.cxx )
ot_add_source_file ( InputTableModel.cxx )
ot_add_source_file ( InputTableProbabilisticModel.cxx )
ot_add_source_file ( OutputTableModel.cxx )
ot_add_source_file ( ExperimentTableModel.cxx )
ot_add_source_file ( CorrelationTableModel.cxx )
ot_add_source_file ( DifferentiationTableModel.cxx )
ot_add_source_file ( DataModelTableModel.cxx )
ot_add_source_file ( DataCleaningTableModel.cxx )
ot_add_source_file ( DistributionsTableModel.cxx )
ot_add_source_file ( CalibrationTableModel.cxx )
ot_add_source_file ( ItemFactory.cxx )
ot_add_source_file ( Item.cxx )
ot_add_source_file ( MeshItem.cxx )
ot_add_source_file ( PhysicalModelDiagramItem.cxx )
ot_add_source_file ( PhysicalModelDefinitionItem.cxx )
ot_add_source_file ( LimitStateItem.cxx )
ot_add_source_file ( DesignOfExperimentItem.cxx )
ot_add_source_file ( DesignOfExperimentDefinitionItem.cxx )
ot_add_source_file ( DataModelDiagramItem.cxx )
ot_add_source_file ( DataModelDefinitionItem.cxx )
ot_add_source_file ( ProbabilisticModelItem.cxx )
ot_add_source_file ( PhysicalModelItem.cxx )
ot_add_source_file ( StudyItem.cxx )
ot_add_source_file ( AnalysisItem.cxx )
ot_add_source_file ( ObservationsItem.cxx )
ot_add_source_file ( StudyTreeViewModel.cxx )
ot_add_source_file ( CodeModel.cxx)
ot_add_source_file ( VariablesSelectionTableModel.cxx)
ot_add_source_file ( CustomStandardItemModel.cxx )
ot_add_source_file ( DependenciesTableModel.cxx )
ot_add_source_file ( OptimizationTableModel.cxx )
ot_add_source_file ( MultiObjectiveOptimizationTableModel.cxx )
ot_add_source_file ( ConstraintsTableModel.cxx )
ot_add_source_file ( ObjectivesTableModel.cxx )
ot_add_source_file ( TranslationManager.cxx )
ot_add_source_file ( FileTools.cxx )
if (OTMORRIS_FOUND)
  ot_add_source_file ( MorrisTableModel.cxx )
  ot_add_source_file ( MorrisResultTableModel.cxx )
endif ()

ot_install_header_file ( SampleTableModel.hxx )
ot_install_header_file ( InputTableModel.hxx )
ot_install_header_file ( InputTableProbabilisticModel.hxx )
ot_install_header_file ( OutputTableModel.hxx )
ot_install_header_file ( ExperimentTableModel.hxx )
ot_install_header_file ( CorrelationTableModel.hxx )
ot_install_header_file ( DifferentiationTableModel.hxx )
ot_install_header_file ( CalibrationTableModel.hxx )
ot_install_header_file ( ItemFactory.hxx )
ot_install_header_file ( Item.hxx )
ot_install_header_file ( MeshItem.hxx )
ot_install_header_file ( PhysicalModelDiagramItem.hxx )
ot_install_header_file ( PhysicalModelDefinitionItem.hxx )
ot_install_header_file ( AnalysisItem.hxx )
ot_install_header_file ( LimitStateItem.hxx )
ot_install_header_file ( DesignOfExperimentItem.hxx )
ot_install_header_file ( DesignOfExperimentDefinitionItem.hxx )
ot_install_header_file ( DataModelDiagramItem.hxx )
ot_install_header_file ( DataModelDefinitionItem.hxx )
ot_install_header_file ( ProbabilisticModelItem.hxx )
ot_install_header_file ( PhysicalModelItem.hxx )
ot_install_header_file ( StudyItem.hxx )
ot_install_header_file ( ObservationsItem.hxx )
ot_install_header_file ( StudyTreeViewModel.hxx )
ot_install_header_file ( VariablesSelectionTableModel.hxx )
ot_install_header_file ( CustomStandardItemModel.hxx )
ot_install_header_file ( DependenciesTableModel.hxx )
ot_install_header_file ( OptimizationTableModel.hxx )
ot_install_header_file ( MultiObjectiveOptimizationTableModel.hxx )
ot_install_header_file ( ConstraintsTableModel.hxx )
ot_install_header_file ( ObjectivesTableModel.hxx )
ot_install_header_file ( TranslationManager.hxx )
ot_install_header_file ( FileTools.hxx )
if (OTMORRIS_FOUND)
ot_install_header_file ( MorrisTableModel.hxx )
ot_install_header_file ( MorrisResultTableModel.hxx )
endif ()

qt_wrap_cpp ( PERSALYS_MODEL_MOC_SRCS persalys/InputTableModel.hxx
                                    persalys/InputTableProbabilisticModel.hxx
                                    persalys/OutputTableModel.hxx
                                    persalys/SampleTableModel.hxx
                                    persalys/ExperimentTableModel.hxx
                                    persalys/CorrelationTableModel.hxx
                                    persalys/DifferentiationTableModel.hxx
                                    persalys/DataModelTableModel.hxx
                                    persalys/DataCleaningTableModel.hxx
                                    persalys/DistributionsTableModel.hxx
                                    persalys/CalibrationTableModel.hxx
                                    persalys/ItemFactory.hxx
                                    persalys/Item.hxx
                                    persalys/MeshItem.hxx
                                    persalys/PhysicalModelDiagramItem.hxx
                                    persalys/PhysicalModelDefinitionItem.hxx
                                    persalys/AnalysisItem.hxx
                                    persalys/StudyTreeViewModel.hxx
                                    persalys/LimitStateItem.hxx
                                    persalys/DesignOfExperimentItem.hxx
                                    persalys/DesignOfExperimentDefinitionItem.hxx
                                    persalys/DataModelDiagramItem.hxx
                                    persalys/DataModelDefinitionItem.hxx
                                    persalys/ProbabilisticModelItem.hxx
                                    persalys/PhysicalModelItem.hxx
                                    persalys/StudyItem.hxx
                                    persalys/ObservationsItem.hxx
                                    persalys/CodeModel.hxx
                                    persalys/VariablesSelectionTableModel.hxx
                                    persalys/CustomStandardItemModel.hxx
                                    persalys/DependenciesTableModel.hxx
                                    persalys/OptimizationTableModel.hxx
                                    persalys/MultiObjectiveOptimizationTableModel.hxx
                                    persalys/ConstraintsTableModel.hxx
                                    persalys/ObjectivesTableModel.hxx
                                    persalys/TranslationManager.hxx
                                    persalys/FileTools.hxx)

if (OTMORRIS_FOUND)
  qt_wrap_cpp (PERSALYS_MODEL_MOC_SRCS persalys/MorrisTableModel.hxx)
  qt_wrap_cpp (PERSALYS_MODEL_MOC_SRCS persalys/MorrisResultTableModel.hxx)
endif ()

if (SalomeYACS_FOUND)
  set_source_files_properties (StudyItem.cxx PROPERTIES COTIRE_EXCLUDED ON SKIP_UNITY_BUILD_INCLUSION ON) # FIXME: Python/Qt conflict due to YACS
endif ()

include_directories ( ${INTERNAL_INCLUDE_DIRS} )

persalys_add_library ( persalysmodel ${SOURCEFILES} ${PERSALYS_MODEL_MOC_SRCS} )

if (BUILD_SHARED_LIBS)
  target_compile_definitions (persalysmodel PRIVATE PERSALYS_MODEL_DLL_EXPORTS)
else ()
  target_compile_definitions (persalysmodel PUBLIC PERSALYS_MODEL_STATIC)
endif ()

if ( NOT DEFINED LIB_VERSION )
  set ( LIB_VERSION 0.0.0 )
endif ()
if ( NOT DEFINED LIB_SOVERSION )
  set ( LIB_SOVERSION 0 )
endif ()
set_target_properties ( persalysmodel PROPERTIES VERSION ${LIB_VERSION} )
set_target_properties ( persalysmodel PROPERTIES SOVERSION ${LIB_SOVERSION} )
target_link_libraries ( persalysmodel persalysbase ${QT_LIBRARIES})

install ( TARGETS persalysmodel
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${PERSALYS_LIBRARY_PATH}
  ARCHIVE DESTINATION ${PERSALYS_LIBRARY_PATH}
)

=== lib/src/view/CMakeLists.txt ===
add_subdirectory (PyInterp)
add_subdirectory (PyConsole)
add_subdirectory (utils)
add_subdirectory (plot)

set (SOURCEFILES "" CACHE STRING "" FORCE)

ot_add_current_dir_to_include_dirs ()

ot_add_source_file ( MainWindow.cxx )
ot_add_source_file ( MainWidget.cxx )
ot_add_source_file ( ToolBar.cxx )
ot_add_source_file ( Actions.cxx )
ot_add_source_file ( MenuBar.cxx )
ot_add_source_file ( StatusBar.cxx )
ot_add_source_file ( SubWindow.cxx )
ot_add_source_file ( DiagramWindow.cxx )
ot_add_source_file ( Wizard.cxx )
ot_add_source_file ( SubWindowsStackedWidget.cxx )
ot_add_source_file ( StudyManager.cxx )
ot_add_source_file ( WindowFactory.cxx )
ot_add_source_file ( Controller.cxx )
ot_add_source_file ( PhysicalModelDiagramWindow.cxx )
ot_add_source_file ( FieldModelDiagramWindow.cxx )
ot_add_source_file ( DataModelDiagramWindow.cxx )
ot_add_source_file ( DataModelWindow.cxx )
ot_add_source_file ( DataAnalysisWindow.cxx )
ot_add_source_file ( DataAnalysisResultWindow.cxx )
ot_add_source_file ( AnalysisWizard.cxx )
ot_add_source_file ( WelcomeWindow.cxx )
ot_add_source_file ( StudyWindow.cxx )
ot_add_source_file ( MeshWindow.cxx )
ot_add_source_file ( BlockSizeGroupBox.cxx )
ot_add_source_file ( MinMaxTableGroupBox.cxx )
ot_add_source_file ( MomentsEstimatesTableGroupBox.cxx )
ot_add_source_file ( OutputsSelectionGroupBox.cxx )
ot_add_source_file ( ParametersWidget.cxx )
ot_add_source_file ( ResultWindow.cxx )
ot_add_source_file ( AnalysisWindow.cxx )
ot_add_source_file ( DesignOfExperimentIntroPage.cxx )
ot_add_source_file ( GridDesignPage.cxx )
ot_add_source_file ( ProbabilisticDesignPage.cxx )
ot_add_source_file ( DesignOfExperimentInputWindow.cxx )
ot_add_source_file ( DesignOfExperimentEvaluationWizard.cxx )
ot_add_source_file ( ImportedDesignPage.cxx )
ot_add_source_file ( PhysicalModelWindowWidget.cxx )
ot_add_source_file ( SymbolicPhysicalModelWindow.cxx )
ot_add_source_file ( PythonPhysicalModelWindow.cxx )
ot_add_source_file ( MetaModelWindow.cxx )
if (SalomeYACS_FOUND)
  ot_add_source_file ( YACSPhysicalModelWindow.cxx)
endif ()
if (OTFMI_FOUND)
  ot_add_source_file ( FMIPhysicalModelWindow.cxx)
endif ()
ot_add_source_file ( ProbabilisticModelWindow.cxx )
ot_add_source_file ( DesignOfExperimentWizard.cxx )
ot_add_source_file ( DesignOfExperimentWindow.cxx )
ot_add_source_file ( StudyTreeView.cxx )
ot_add_source_file ( ModelEvaluationWizard.cxx )
ot_add_source_file ( ModelEvaluationResultWindow.cxx )
ot_add_source_file ( CentralTendencyIntroPage.cxx )
ot_add_source_file ( MonteCarloPage.cxx )
ot_add_source_file ( CentralTendencyWizard.cxx )
ot_add_source_file ( MonteCarloResultWindow.cxx )
ot_add_source_file ( TaylorExpansionMomentsResultWindow.cxx )
ot_add_source_file ( SensitivityResultWidget.cxx )
ot_add_source_file ( SobolResultWindow.cxx )
ot_add_source_file ( SRCResultWindow.cxx )
ot_add_source_file ( SensitivityIntroPage.cxx )
ot_add_source_file ( SobolPage.cxx )
ot_add_source_file ( SRCPage.cxx )
ot_add_source_file ( SensitivityAnalysisWizard.cxx )
ot_add_source_file ( LimitStateWindow.cxx )
ot_add_source_file ( ReliabilityIntroPage.cxx )
ot_add_source_file ( SimulationReliabilityPage.cxx )
ot_add_source_file ( ApproximationReliabilityPage.cxx )
ot_add_source_file ( ReliabilityAnalysisWizard.cxx )
ot_add_source_file ( SimulationReliabilityResultWindow.cxx )
ot_add_source_file ( ApproximationResultWindow.cxx )
ot_add_source_file ( ApproximationResultTabWidget.cxx )
ot_add_source_file ( StopCriteriaGroupBox.cxx )
ot_add_source_file ( ParametersDefinitionWizard.cxx )
ot_add_source_file ( MetaModelIntroPage.cxx )
ot_add_source_file ( KrigingPage.cxx )
ot_add_source_file ( FunctionalChaosPage.cxx )
ot_add_source_file ( PolynomialRegressionPage.cxx )
ot_add_source_file ( MetaModelAnalysisWizard.cxx )
ot_add_source_file ( MetaModelExportWizard.cxx )
ot_add_source_file ( MetaModelValidationPage.cxx )
ot_add_source_file ( MetaModelValidationWidget.cxx )
ot_add_source_file ( FunctionalChaosResultWindow.cxx )
ot_add_source_file ( KrigingResultWindow.cxx )
ot_add_source_file ( PolynomialRegressionResultWindow.cxx )
ot_add_source_file ( InferenceWizard.cxx )
ot_add_source_file ( InferenceResultWindow.cxx )
ot_add_source_file ( DistributionsForInferenceWidget.cxx )
ot_add_source_file ( InferenceResultWizard.cxx )
ot_add_source_file ( InferenceResultWidget.cxx )
ot_add_source_file ( CopulaParametersTabWidget.cxx )
ot_add_source_file ( CopulaInferenceResultWidget.cxx )
ot_add_source_file ( CopulaInferenceResultWindow.cxx )
ot_add_source_file ( OptimizationAlgoPage.cxx )
ot_add_source_file ( ConstraintsPage.cxx )
ot_add_source_file ( OptimizationWizard.cxx )
ot_add_source_file ( OptimizationResultWindow.cxx )
ot_add_source_file ( MultiObjectiveOptimizationResultWindow.cxx )
ot_add_source_file ( MultiObjectiveOptimizationWizard.cxx )
ot_add_source_file ( WidgetBoundToDockWidget.cxx )
ot_add_source_file ( MarginalsWidget.cxx )
ot_add_source_file ( DependenciesWidget.cxx )
ot_add_source_file ( CopulaWidget.cxx )
ot_add_source_file ( CopulaInferenceWizard.cxx )
ot_add_source_file ( CopulaInferenceResultWizard.cxx )
ot_add_source_file ( AboutDialog.cxx )
ot_add_source_file ( SettingsDialog.cxx )
ot_add_source_file ( MeshDefinitionWizard.cxx )
ot_add_source_file ( FieldModelEvaluationResultWindow.cxx )
ot_add_source_file ( FieldMonteCarloWizard.cxx )
ot_add_source_file ( ExtractDataFieldWizard.cxx )
ot_add_source_file ( ImportSampleWidget.cxx )
ot_add_source_file ( ObservationsWizard.cxx )
ot_add_source_file ( CalibrationAnalysisWizard.cxx )
ot_add_source_file ( CalibrationResultWindow.cxx )
ot_add_source_file ( CouplingModelWindow.cxx )
ot_add_source_file ( DataCleaningWizard.cxx )
ot_add_source_file ( AnsysWizard.cxx )
if (OTMORRIS_FOUND)
  ot_add_source_file ( ScreeningIntroPage.cxx )
  ot_add_source_file ( MorrisPage.cxx )
  ot_add_source_file ( ScreeningAnalysisWizard.cxx )
  ot_add_source_file ( MorrisResultWidget.cxx )
  ot_add_source_file ( MorrisResultWindow.cxx )
  ot_add_source_file ( ScreeningResultWizard.cxx )
endif ()

ot_install_header_file ( MainWindow.hxx )
ot_install_header_file ( MainWidget.hxx )
ot_install_header_file ( Actions.hxx )
ot_install_header_file ( ToolBar.hxx )
ot_install_header_file ( MenuBar.hxx )
ot_install_header_file ( DiagramWindow.hxx )
ot_install_header_file ( StatusBar.hxx )
ot_install_header_file ( Wizard.hxx )
ot_install_header_file ( SubWindowsStackedWidget.hxx )
ot_install_header_file ( StudyManager.hxx )
ot_install_header_file ( WindowFactory.hxx )
ot_install_header_file ( AnalysisWizard.hxx )
ot_install_header_file ( WelcomeWindow.hxx )
ot_install_header_file ( StudyWindow.hxx )
ot_install_header_file ( MeshWindow.hxx )
ot_install_header_file ( PhysicalModelDiagramWindow.hxx )
ot_install_header_file ( FieldModelDiagramWindow.hxx )
ot_install_header_file ( DataModelDiagramWindow.hxx )
ot_install_header_file ( ResultWindow.hxx )
ot_install_header_file ( BlockSizeGroupBox.hxx )
ot_install_header_file ( MinMaxTableGroupBox.hxx )
ot_install_header_file ( MomentsEstimatesTableGroupBox.hxx )
ot_install_header_file ( OutputsSelectionGroupBox.hxx )
ot_install_header_file ( ParametersWidget.hxx )
ot_install_header_file ( DataModelWindow.hxx )
ot_install_header_file ( DataAnalysisWindow.hxx )
ot_install_header_file ( DataAnalysisResultWindow.hxx )
ot_install_header_file ( AnalysisWindow.hxx )
ot_install_header_file ( ModelEvaluationWizard.hxx )
ot_install_header_file ( CentralTendencyIntroPage.hxx )
ot_install_header_file ( MonteCarloPage.hxx )
ot_install_header_file ( CentralTendencyWizard.hxx )
ot_install_header_file ( SensitivityIntroPage.hxx )
ot_install_header_file ( SobolPage.hxx )
ot_install_header_file ( SRCPage.hxx )
ot_install_header_file ( SensitivityAnalysisWizard.hxx )
ot_install_header_file ( LimitStateWindow.hxx )
ot_install_header_file ( ReliabilityIntroPage.hxx )
ot_install_header_file ( SimulationReliabilityPage.hxx )
ot_install_header_file ( ApproximationReliabilityPage.hxx )
ot_install_header_file ( ReliabilityAnalysisWizard.hxx )
ot_install_header_file ( SubWindow.hxx )
ot_install_header_file ( PhysicalModelWindowWidget.hxx )
ot_install_header_file ( SymbolicPhysicalModelWindow.hxx )
ot_install_header_file ( PythonPhysicalModelWindow.hxx )
ot_install_header_file ( MetaModelWindow.hxx )
if (SalomeYACS_FOUND)
  ot_install_header_file (YACSPhysicalModelWindow.hxx)
endif ()
if (OTFMI_FOUND)
  ot_install_header_file (FMIPhysicalModelWindow.hxx)
endif ()
ot_install_header_file ( ProbabilisticModelWindow.hxx )
ot_install_header_file ( DesignOfExperimentWizard.hxx )
ot_install_header_file ( DesignOfExperimentWindow.hxx )
ot_install_header_file ( ModelEvaluationResultWindow.hxx )
ot_install_header_file ( MonteCarloResultWindow.hxx )
ot_install_header_file ( TaylorExpansionMomentsResultWindow.hxx )
ot_install_header_file ( SensitivityResultWidget.hxx )
ot_install_header_file ( SobolResultWindow.hxx )
ot_install_header_file ( SRCResultWindow.hxx )
ot_install_header_file ( SimulationReliabilityResultWindow.hxx )
ot_install_header_file ( ApproximationResultWindow.hxx )
ot_install_header_file ( ApproximationResultTabWidget.hxx )
ot_install_header_file ( StudyTreeView.hxx )
ot_install_header_file ( DesignOfExperimentIntroPage.hxx )
ot_install_header_file ( GridDesignPage.hxx )
ot_install_header_file ( ProbabilisticDesignPage.hxx )
ot_install_header_file ( ImportedDesignPage.hxx )
ot_install_header_file ( DesignOfExperimentInputWindow.hxx )
ot_install_header_file ( DesignOfExperimentEvaluationWizard.hxx )
ot_install_header_file ( StopCriteriaGroupBox.hxx )
ot_install_header_file ( ParametersDefinitionWizard.hxx )
ot_install_header_file ( MetaModelIntroPage.hxx )
ot_install_header_file ( KrigingPage.hxx )
ot_install_header_file ( FunctionalChaosPage.hxx )
ot_install_header_file ( PolynomialRegressionPage.hxx )
ot_install_header_file ( MetaModelAnalysisWizard.hxx )
ot_install_header_file ( MetaModelExportWizard.hxx )
ot_install_header_file ( MetaModelValidationPage.hxx )
ot_install_header_file ( MetaModelValidationWidget.hxx )
ot_install_header_file ( FunctionalChaosResultWindow.hxx )
ot_install_header_file ( KrigingResultWindow.hxx )
ot_install_header_file ( PolynomialRegressionResultWindow.hxx )
ot_install_header_file ( InferenceResultWindow.hxx )
ot_install_header_file ( InferenceResultWizard.hxx )
ot_install_header_file ( InferenceResultWidget.hxx )
ot_install_header_file ( Controller.hxx )
ot_install_header_file ( ControllerWidget.hxx )
ot_install_header_file ( CopulaInferenceResultWidget.hxx )
ot_install_header_file ( CopulaInferenceResultWindow.hxx )
ot_install_header_file ( CopulaParametersTabWidget.hxx )
ot_install_header_file ( OptimizationAlgoPage.hxx )
ot_install_header_file ( ConstraintsPage.hxx )
ot_install_header_file ( OptimizationWizard.hxx )
ot_install_header_file ( OptimizationResultWindow.hxx )
ot_install_header_file ( MultiObjectiveOptimizationResultWindow.hxx )
ot_install_header_file ( MultiObjectiveOptimizationWizard.hxx )
ot_install_header_file ( WidgetBoundToDockWidget.hxx )
ot_install_header_file ( MarginalsWidget.hxx )
ot_install_header_file ( DependenciesWidget.hxx )
ot_install_header_file ( CopulaWidget.hxx )
ot_install_header_file ( CopulaInferenceWizard.hxx )
ot_install_header_file ( CopulaInferenceResultWizard.hxx )
ot_install_header_file ( AboutDialog.hxx )
ot_install_header_file ( SettingsDialog.hxx )
ot_install_header_file ( MeshDefinitionWizard.hxx )
ot_install_header_file ( FieldModelEvaluationResultWindow.hxx )
ot_install_header_file ( FieldMonteCarloWizard.hxx )
ot_install_header_file ( ExtractDataFieldWizard.hxx )
ot_install_header_file ( ImportSampleWidget.hxx )
ot_install_header_file ( ObservationsWizard.hxx )
ot_install_header_file ( ObservationsWindow.hxx )
ot_install_header_file ( CalibrationAnalysisWizard.hxx )
ot_install_header_file ( CalibrationResultWindow.hxx )
ot_install_header_file ( CouplingModelWindow.hxx )
ot_install_header_file ( DataCleaningWizard.hxx )

=== lib/src/view/PyConsole/CMakeLists.txt ===

set (SOURCEFILES "" CACHE STRING "" FORCE)

ot_add_current_dir_to_include_dirs ()

ot_add_source_file (PyConsole_Console.cxx)
ot_add_source_file (PyConsole_Event.cxx)
ot_add_source_file (PyConsole_Interp.cxx)
ot_add_source_file (PyConsole_Request.cxx)
ot_add_source_file (PyConsole_Editor.cxx)

# ot_install_header_file (PyConsole.h)
# ot_install_header_file (PyConsole_Event.h)
# ot_install_header_file (PyConsole_Interp.h)
# ot_install_header_file (PyConsole_Request.h)

qt_wrap_cpp (PERSALYS_CONSOLE_MOC_SRCS
              PyConsole_Console.h
              PyConsole_Editor.h)

include_directories (${INTERNAL_INCLUDE_DIRS})
persalys_add_library (persalyspyconsole ${SOURCEFILES} ${PERSALYS_CONSOLE_MOC_SRCS})

if ( BUILD_SHARED_LIBS )
  target_compile_definitions (persalyspyconsole PRIVATE PERSALYS_DLL_EXPORTS PyConsole_EXPORTS)
endif ()

if ( NOT DEFINED LIB_VERSION ) 
  set ( LIB_VERSION 0.0.0 )
endif ()
if ( NOT DEFINED LIB_SOVERSION ) 
  set ( LIB_SOVERSION 0 )
endif ()
set_target_properties (persalyspyconsole PROPERTIES VERSION ${LIB_VERSION})
set_target_properties (persalyspyconsole PROPERTIES SOVERSION ${LIB_SOVERSION})

include_directories (${PYTHON_INCLUDE_DIRS})
target_link_libraries (persalyspyconsole ${QT_LIBRARIES})
target_link_libraries (persalyspyconsole ${PYTHON_LIBRARIES})
if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 8)
  target_compile_definitions (persalyspyconsole PRIVATE MS_WIN64)
endif ()

target_link_libraries (persalyspyconsole persalyspyinterp)

install ( TARGETS persalyspyconsole
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${PERSALYS_LIBRARY_PATH}
  ARCHIVE DESTINATION ${PERSALYS_LIBRARY_PATH}
)

=== lib/src/view/PyInterp/CMakeLists.txt ===
set (SOURCEFILES "" CACHE STRING "" FORCE)

ot_add_current_dir_to_include_dirs ()

ot_add_source_file (PyInterp_Dispatcher.cxx)
ot_add_source_file (PyInterp_Event.cxx)
ot_add_source_file (PyInterp_Interp.cxx)
ot_add_source_file (PyInterp_Request.cxx)

# ot_install_header_file (PyInterp.h)
# ot_install_header_file (PyInterp_Event.h)
# ot_install_header_file (PyInterp_Interp.h)
# ot_install_header_file (PyInterp_Request.h)
# ot_install_header_file (PyInterp_Utils.h)

qt_wrap_cpp (PERSALYS_CONSOLE_MOC_SRCS
              PyInterp_Dispatcher.h)

include_directories (${INTERNAL_INCLUDE_DIRS})
persalys_add_library (persalyspyinterp ${SOURCEFILES} ${PERSALYS_CONSOLE_MOC_SRCS})

if ( BUILD_SHARED_LIBS )
  target_compile_definitions (persalyspyinterp PRIVATE PERSALYS_DLL_EXPORTS PyInterp_EXPORTS)
endif ()

if ( NOT DEFINED LIB_VERSION ) 
  set ( LIB_VERSION 0.0.0 )
endif ()
if ( NOT DEFINED LIB_SOVERSION ) 
  set ( LIB_SOVERSION 0 )
endif ()
set_target_properties (persalyspyinterp PROPERTIES VERSION ${LIB_VERSION})
set_target_properties (persalyspyinterp PROPERTIES SOVERSION ${LIB_SOVERSION})

include_directories (${PYTHON_INCLUDE_DIRS})
target_link_libraries (persalyspyinterp ${QT_LIBRARIES})
target_link_libraries (persalyspyinterp ${PYTHON_LIBRARIES})
if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 8)
  target_compile_definitions (persalyspyinterp PRIVATE MS_WIN64)
endif ()

install ( TARGETS persalyspyinterp
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${PERSALYS_LIBRARY_PATH}
  ARCHIVE DESTINATION ${PERSALYS_LIBRARY_PATH}
)

=== lib/src/view/plot/CMakeLists.txt ===
if (ParaView_FOUND)
  add_subdirectory (pv)
endif ()

set (SOURCEFILES "" CACHE STRING "" FORCE)

ot_add_current_dir_to_include_dirs ()

ot_add_source_file (CustomScaleEngine.cxx)
ot_add_source_file (CustomScaleDraw.cxx)
ot_add_source_file (PlotWidget.cxx)
ot_add_source_file (ContourPlot.cxx)
ot_add_source_file (MorrisPlot.cxx)
ot_add_source_file (BoxPlot.cxx)
ot_add_source_file (SensitivityIndicesPlot.cxx)
ot_add_source_file (PieChartView.cxx)
ot_add_source_file (PlotMatrixWidget.cxx)
ot_add_source_file (GraphConfigurationWidget.cxx)
ot_add_source_file (PlotMatrixConfigurationWidget.cxx)

ot_install_header_file ( CustomScaleEngine.hxx )
ot_install_header_file ( CustomScaleDraw.hxx )
ot_install_header_file ( PlotWidget.hxx )
ot_install_header_file ( ContourPlot.hxx )
ot_install_header_file ( MorrisPlot.hxx )
ot_install_header_file ( BoxPlot.hxx )
ot_install_header_file ( SensitivityIndicesPlot.hxx )
ot_install_header_file ( PieChartView.hxx )
ot_install_header_file ( PlotMatrixWidget.hxx )
ot_install_header_file ( GraphConfigurationWidget.hxx )
ot_install_header_file ( PlotMatrixConfigurationWidget.hxx )

qt_wrap_cpp (PERSALYS_PLOT_MOC_SRCS
              persalys/PlotWidget.hxx
              persalys/ContourPlot.hxx
              persalys/MorrisPlot.hxx
              persalys/BoxPlot.hxx
              persalys/SensitivityIndicesPlot.hxx
              persalys/PieChartView.hxx
              persalys/PlotMatrixWidget.hxx
              persalys/GraphConfigurationWidget.hxx
              persalys/PlotMatrixConfigurationWidget.hxx)

include_directories (${INTERNAL_INCLUDE_DIRS})
persalys_add_library (persalysplot ${SOURCEFILES} ${PERSALYS_PLOT_MOC_SRCS})

if (BUILD_SHARED_LIBS)
  target_compile_definitions (persalysplot PRIVATE PERSALYS_PLOT_DLL_EXPORTS)
else ()
  target_compile_definitions (persalysplot PUBLIC PERSALYS_PLOT_STATIC)
endif ()

if ( NOT DEFINED LIB_VERSION ) 
  set ( LIB_VERSION 0.0.0 )
endif ()
if ( NOT DEFINED LIB_SOVERSION ) 
  set ( LIB_SOVERSION 0 )
endif ()
set_target_properties ( persalysplot PROPERTIES VERSION ${LIB_VERSION} )
set_target_properties ( persalysplot PROPERTIES SOVERSION ${LIB_SOVERSION} )
target_link_libraries ( persalysplot persalysutils )

include_directories (${QWT_INCLUDE_DIRS})
target_link_libraries (persalysplot ${QT_LIBRARIES})
target_link_libraries (persalysplot ${QWT_LIBRARIES})
if (ParaView_FOUND)
  target_link_libraries (persalysplot persalysplotpv)
endif ()

install ( TARGETS persalysplot
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${PERSALYS_LIBRARY_PATH}
  ARCHIVE DESTINATION ${PERSALYS_LIBRARY_PATH}
)

=== debian/changelog ===
persalys (13.1.1+ds-1) unstable; urgency=medium

  * New upstream version 13.1.1+ds
  * Raising Standards version to 4.6.2 (no change)
  * Removing all patches, which have been upstreamed
  * Changing the path of generated Python files for the install step
  * Hardening
  * Correcting a minor spelling error

 -- Pierre Gruet <pgt@debian.org>  Tue, 20 Dec 2022 09:16:14 +0100

persalys (12.0.1+ds-3) unstable; urgency=medium

  * Running the tests with xvfb-run to avoid skipping X11-dependent tests
  * Simplifying d/rules
  * Comparing doubles by testing if the absolute value of their difference is
    small, instead of using ==
  * Set upstream metadata fields: Repository.
  * Conforming to the openturns 1.20 ABI

 -- Pierre Gruet <pgt@debian.org>  Sat, 26 Nov 2022 07:18:29 +0100

=== debian/control ===
Source: persalys
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Pierre Gruet <pgt@debian.org>,
           Julien Schueller <schueller@phimeca.com>
Build-Depends: debhelper-compat (= 13),
               cmake,
               dh-python,
               python3-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>
Build-Depends-Arch: gfortran,
                    docbook-to-man,
                    libboost-filesystem-dev,
                    libboost-locale-dev,
                    libhmat-oss-dev,
                    libopenturns-dev,
                    libqt5opengl5-dev,
                    libqwt-qt5-dev,
                    poppler-utils,
                    python3-openturns,
                    swig,
                    texlive,
                    texlive-latex-extra
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/persalys
Vcs-Git: https://salsa.debian.org/science-team/persalys.git
Homepage: https://www.persalys.fr/
Rules-Requires-Root: no

Package: libpersalys0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: GUI for uncertainty treatment (shared libraries)
 Persalys is a graphical user interface for OpenTURNS, dedicated to the
 treatment of uncertainty and the management of variabilities. The software is
 a tool between the computer simulation, probabilistic analyses and the data
 sciences. The interface is available in French or in English.
 .
 Persalys allows one to:
  - create mathematical models: analytical, coupling with an external model
  (finite elements, ...), FMU;
  - analyse the variability of one's parameters thanks to many methods and
  visualisation tools;
  - statistically analyse one's measuring data, infer probability distributions
  or create metamodels.
 .
 This package contains the shared libraries.

Package: libpersalys-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends},
         libpersalys0 (= ${binary:Version}),
         ${misc:Depends}
Description: GUI for uncertainty treatment (development files)
 Persalys is a graphical user interface for OpenTURNS, dedicated to the
 treatment of uncertainty and the management of variabilities. The software is
 a tool between the computer simulation, probabilistic analyses and the data
 sciences. The interface is available in French or in English.
 .
 Persalys allows one to:
  - create mathematical models: analytical, coupling with an external model
  (finite elements, ...), FMU;
  - analyse the variability of one's parameters thanks to many methods and
  visualisation tools;
  - statistically analyse one's measuring data, infer probability distributions
  or create metamodels.
 .
 This package contains the development files.

Package: persalys
Architecture: any
Depends: ${shlibs:Depends},
         libpersalys0 (= ${binary:Version}),
         python3-persalys (= ${binary:Version}),
         ${misc:Depends}
Description: GUI for uncertainty treatment and variabilities management
 Persalys is a graphical user interface for OpenTURNS, dedicated to the
 treatment of uncertainty and the management of variabilities. The software is
 a tool between the computer simulation, probabilistic analyses and the data
 sciences. The interface is available in French or in English.
 .
 Persalys allows one to:
  - create mathematical models: analytical, coupling with an external model
  (finite elements, ...), FMU;
  - analyse the variability of one's parameters thanks to many methods and
  visualisation tools;
  - statistically analyse one's measuring data, infer probability distributions
  or create metamodels.

Package: python3-persalys
Section: python
Architecture: any
Depends: ${shlibs:Depends},
         libpersalys0 (= ${binary:Version}),
         python3-openturns,
         ${misc:Depends},
         ${python3:Depends}
Description: GUI for uncertainty treatment (Python bindings)
 Persalys is a graphical user interface for OpenTURNS, dedicated to the
 treatment of uncertainty and the management of variabilities. The software is
 a tool between the computer simulation, probabilistic analyses and the data
 sciences. The interface is available in French or in English.
 .
 Persalys allows one to:
  - create mathematical models: analytical, coupling with an external model
  (finite elements, ...), FMU;
  - analyse the variability of one's parameters thanks to many methods and
  visualisation tools;
  - statistically analyse one's measuring data, infer probability distributions
  or create metamodels.
 .
 This package contains the Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	test_makeflags = -j$(NUMJOBS)
endif

%:
	dh $@ --buildsystem=cmake --with python3

override_dh_auto_clean:
	# If we populated a persalys directory for Python modules during the tests,
	# we remove them.
	if [ -e builddir/lib/test/persalys ]; then rm -rf builddir/lib/test/persalys; fi
	if [ -e python/test/persalys ]; then rm -rf python/test/persalys; fi
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -Bbuilddir -- \
            -DUSE_SPHINX=OFF \
            -DUSE_SALOME=OFF \
            -DCMAKE_CXX_FLAGS:STRING="$(CXXFLAGS)" \
            -DCMAKE_MODULE_LINKER_FLAGS:STRING="$(LDFLAGS)" \
            -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/persalys \
            -DLINK_PYTHON_LIBRARY:BOOL=OFF \
            -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python3

override_dh_auto_build:
	$(MAKE) $(test_makeflags) -C builddir

override_dh_auto_install:
	dh_auto_install -Bbuilddir
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# Building the folder of the persalys Python module in the Python test
	# directory so that it is found during the tests.
	if [ ! -e python/test/persalys ]; then \
	        mkdir python/test/persalys ; \
	        cp python/src/__init__.py python/test/persalys ; \
	        cp builddir/python/src/persalys.py python/test/persalys ; \
	        cp builddir/python/src/_persalys*.so python/test/persalys ; \
	fi
	# Looking for the shared lib that is about to be installed.
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH:+$${LD_LIBRARY_PATH}:}$(CURDIR)/debian/libpersalys0/usr/lib/$(DEB_HOST_MULTIARCH) \
	  CTEST_OUTPUT_ON_FAILURE=1 \
	  xvfb-run -s "-screen 0 1024x768x24" $(MAKE) $(test_makeflags) -C builddir test ARGS="$(test_makeflags) -R pyinstallcheck"
	find $(CURDIR)/debian/persalys -name "*.pyc" -o -name "__pycache__" | xargs rm -rf
endif

override_dh_install:
	dh_install
	# Installing and renaming icon
	mkdir -p debian/persalys/usr/share/icons/hicolor/64x64/apps
	cp images/Ps-icon-64.png debian/persalys/usr/share/icons/hicolor/64x64/apps/persalys-icon.png

override_dh_makeshlibs:
	dh_makeshlibs -Xpyshared

override_dh_compress:
	dh_compress -X.pdf -X.svn -X.py

override_dh_auto_test:
	# Building the folder of the persalys Python module in the C++ test directory
	# so that it is found during the tests.
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	if [ ! -e builddir/lib/test/persalys ]; then \
	        mkdir builddir/lib/test/persalys ; \
	        cp python/src/__init__.py builddir/lib/test/persalys ; \
	        cp builddir/python/src/persalys.py builddir/lib/test/persalys ; \
	        cp builddir/python/src/_persalys*.so builddir/lib/test/persalys ; \
	fi
	# 'make test' does not build binary tests
	$(MAKE) $(test_makeflags) -C builddir tests
	CTEST_OUTPUT_ON_FAILURE=1 \
	  xvfb-run -s "-screen 0 1024x768x24" $(MAKE) -C builddir test ARGS="$(test_makeflags) -R cppcheck"
endif
